import {
  ClassType,
} from '@loafer/core/constants/types';

import AppContext from '@loafer/context/AppContext';
import DefaultAppContext from '@loafer/context/implement/DefaultAppContext';

import ApplicationStater from '@loafer/application/ApplicationStater';

class Application {
  private appContext: AppContext;
  private appClass: ClassType;
  private appInstance: ApplicationStater;

  public constructor(clazz: ClassType) {
    this.appClass = clazz;
  }

  public run(): AppContext {
    this.appContext = new DefaultAppContext();
    this.appInstance = this.appContext.getPouchByClass(this.appClass, undefined);

    this.appInstance.start();

    return this.appContext;
  }

  public static run(clazz: ClassType): AppContext {
    return new Application(clazz).run();
  }
}

export default Application;
