import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

import {
  ConfigurationAnnotation,
} from '@loafer/context/decorator/Configuration';

export class AppAnnotation extends ConfigurationAnnotation implements DecoratorHandler {
  public constructor(qualifier?: PropertyType) {
    super(qualifier);
  }
  public onClassDecorator = <TFunction extends Function>(clazz: Class, target: TFunction): TFunction | void => {
    console.log('App');
  }

}

export const App = Decorator.create(AppAnnotation);

export default App;
