import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Class,
} from '@loafer/core/reflect';

export interface DecoratorHandler {
  onClassDecorator?: <TFunction extends Function>(clazz: Class, target: TFunction) => TFunction | void;
  onPropertyDecorator?: (clazz: Class, target: Object, propertyKey: PropertyType) => void;
  onMethodDecorator?: <T>(clazz: Class, target: Object, propertyKey: PropertyType,
                          descriptor: TypedPropertyDescriptor<T>) => TypedPropertyDescriptor<T> | void;
  onParameterDecorator?: (clazz: Class, target: Object, propertyKey: PropertyType, parameterIndex: number) => void;
}

export default DecoratorHandler;
