import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

export class InjectableAnnotation implements DecoratorHandler {
  private readonly Qualifier: PropertyType;

  public constructor(qualifier?: PropertyType) {
    this.Qualifier = qualifier;
  }
  public onClassDecorator = <TFunction extends Function>(clazz: Class, target: TFunction): TFunction | void => {
    console.log('Injectable');
  }

}

export const Injectable = Decorator.create(InjectableAnnotation);

export default Injectable;
